package org.processmining.streamconformance.regions.widgets.renderers;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

import org.processmining.models.graphbased.directed.transitionsystem.State;
import org.processmining.streamconformance.regions.utils.Quadruple;

public class ErrorListEntryRendererWithCost extends JLabel implements ListCellRenderer<Quadruple<State, String, State, Integer>> {

	private static final long serialVersionUID = -1863880605178129502L;

	public ErrorListEntryRendererWithCost() {
	}

	@Override
	public Component getListCellRendererComponent(JList<? extends Quadruple<State, String, State, Integer>> list,
			Quadruple<State, String, State, Integer> value, int index,
			boolean isSelected, boolean cellHasFocus) {

		setFont(getFont().deriveFont(Font.PLAIN));
		setText("<html><b>Error:</b> <em>" + value.getSecond() + "</em></html>");

		setOpaque(true);
		setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
		if (isSelected) {
			setBackground(Color.darkGray);
			setForeground(Color.white);
		} else {
			setBackground(Color.lightGray);
			setForeground(Color.black);
		}

		return this;
	}
}
