package org.processmining.streamconformance.regions.widgets.renderers;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

import org.processmining.framework.util.Pair;
import org.processmining.models.graphbased.directed.transitionsystem.State;
import org.processmining.streamconformance.regions.utils.Triple;

public class FrequentErrorListEntryRenderer extends JLabel implements ListCellRenderer<Pair<Integer, Triple<State, String, State>>> {

	private static final long serialVersionUID = -1863880605178129502L;

	public FrequentErrorListEntryRenderer() {
	}

	@Override
	public Component getListCellRendererComponent(JList<? extends Pair<Integer, Triple<State, String, State>>> list,
			Pair<Integer, Triple<State, String, State>> value,
			int index,
			boolean isSelected, boolean cellHasFocus) {

		setFont(getFont().deriveFont(Font.PLAIN));
		setText("<html><b>Error:</b> <em>" + value.getSecond().getSecond() + "</em><br>"
				+ "<b>Frequency:</b> " + value.getFirst() + " occurrences</html>");

		setOpaque(true);
		setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
		if (isSelected) {
			setBackground(Color.darkGray);
			setForeground(Color.white);
		} else {
			setBackground(Color.lightGray);
			setForeground(Color.black);
		}

		return this;
	}
}
